var GlobalDuckLayer = null;
var DuckLayer = cc.Layer.extend({
    sprite:null,
    ctor:function () {
        this._super();
        GlobalDuckLayer = this;

        this.initGlobal();
        this.addBG();

        this.initPhysics();
        this.addEventManager();
        this.addPropManager();
        this.addTimerManager();
        this.scheduleOnce(function(){
            this.onEnterTransitionDidFinish1();
        }.bind(this),0.1);

        this.scheduleOnce(function(){
            GlobalADIndex++;
            if (recommandEnable() && AD_ENABLE && ARRY_AD_IN && ARRY_AD_IN.length) {
                GlobalADIndex = (GlobalADIndex++)  % ARRY_AD_IN.length;
                this.star_ad = new StarAdLayer(ARRY_AD_IN[GlobalADIndex]);
                this.star_ad.setGlobalZOrder(65535);
                this.star_ad.x = GW - 85;
                this.star_ad.y = - 15;
                this.addChild(this.star_ad, 65535);
            }
        }.bind(this),0.5);

        return true;
    },
    addTestPoint:function(){
        this.testpoint = new TestPoint("res/K/1.png");
        this.addChild(this.testpoint);
        this.testpoint.setGlobalZOrder(3000000);
        this.testpoint.setPosition(GW2,GH2);

        this.testpoint1 = new TestPoint("res/K/picture/common/cloth/cloth_niuzai.png");
        this.addChild(this.testpoint1);
        this.testpoint1.setGlobalZOrder(300000);
        this.testpoint1.setPosition(Config_Play.duck.prop_ok_position.cloth);

        this.testpoint2 = new TestPoint("res/K/picture/common/hat/hat_wuxia.png");
        this.addChild(this.testpoint2);
        this.testpoint2.setGlobalZOrder(300000);
        this.testpoint2.setPosition(Config_Play.duck.prop_ok_position.hat);

        this.testpoint3 = new TestPoint("res/K/picture/common/glass/glass_3d.png");
        this.addChild(this.testpoint3);
        this.testpoint3.setGlobalZOrder(300000);
        this.testpoint3.setPosition(Config_Play.duck.prop_ok_position.glass);

    },
    onExitTransitionDidStart:function(){
        ddStopAllAudios();
        cc.audioEngine.stopAllEffects();
        Config_Play.defaultSkin.duck.hat = this.hero_hat_index;
        Config_Play.defaultSkin.duck.glass = this.hero_glass_index;
        Config_Play.defaultSkin.duck.cloth = this.hero_cloth_index;
    },
    onEnterTransitionDidFinish1:function(){
        ddStopAllAudios();
        cc.audioEngine.stopAllEffects();
        this.addHero();
        this.addDebugNode();
        this.startGame();
    },
    addBG:function(){
        var back = new cc.Sprite("res/K/picture/scene/duck/background.png");
        back.setAnchorPoint(cc.p(0.5, 0));
        back.x = cc.winSize.width / 2;
        back.y = 0;
        this.addChild(back);
        back.scaleX = 1.2


        ddPlayEffect("effect","res/K/audio/game/enter.mp3",false);
        this.background = createStaticNode_AP("res/K/picture/scene/duck/beijing.png",this,cc.p(0+offsetX(),0),3,cc.p(0,0));
        this.guizidi = createStaticNode("res/K/picture/scene/duck/guizidi.png",this,cc.p(GW-205-offsetX(),276),1);
        this.yijia = createStaticNode("res/K/yijia.png",this,cc.p(GW-200-offsetX(),349),2);
    },
    initPhysics:function(){
        this.space = initPhysics(this);
        showDebug(this);
        this.scheduleUpdate();
    },
    addHero:function(){
        this.hero = createSkeletonSprite("res/spine/duck/skeleton.json","res/spine/duck/skeleton.atlas",1,this,cc.p(Config_Play.duck.hero_position.x,Config_Play.duck.hero_position.y*640/GH),100);
        this.hero.setOpacity(0);

        this.hero.runAction(cc.fadeTo(0.1,255));
        // this.hero = getAnimal(3);
        // this.addChild(this.hero);
        // this.hero.setScale(1);
        // this.hero.setPosition(Config_Play.duck.hero_position);
        // this.hero.setZOrder(100);
        this.initHero();

        //用于碰撞检测
        this.hero_cloth = createCustomLayerColor(this,10,10,cc.p(-3+GW2,180*640/GH),1000,"hero_cloth");
        this.hero_hat   = createCustomLayerColor(this,10,10,cc.p(-3+GW2,440*640/GH),1000,"hero_hat");
        this.hero_glass = createCustomLayerColor(this,10,10,cc.p(-2+GW2,325*640/GH),10000,"hero_glass");
        cc.log("duck hero_cloth " +this.hero_cloth.x+","+this.hero_cloth.y);
        cc.log("duck hero_hat " +this.hero_hat.x+","+this.hero_hat.y);
        cc.log("duck hero_glass " +this.hero_glass.x+","+this.hero_glass.y);


        // this.hero_hat_index = findSkinIndex_string_duck("hat","kongbai");
        // this.hero_glass_index = findSkinIndex_string_duck("glass","kongbai");
        // this.hero_cloth_index = findSkinIndex_string_duck("cloth","kongbai");

        // cc.log("kang*** "+this.hero_hat_index);
        this.hero_hat_index = Config_Play.defaultSkin.duck.hat;
        this.hero_glass_index = Config_Play.defaultSkin.duck.glass;
        this.hero_cloth_index = Config_Play.defaultSkin.duck.cloth;

        if(this.hero_hat_index == "8") {
            this.hero_hat_flag_have = false;
        }else{
            this.hero_hat_flag_have = true;
        }
        if(this.hero_glass_index == "4"){
            this.hero_glass_flag_have = false;
        }else{
            this.hero_glass_flag_have = true;
        }
        if(this.hero_cloth_index == "b"){
            this.hero_cloth_flag_have = false;
        }else{
            this.hero_cloth_flag_have = true;
        }
        this.setSkin();


        this.hero_love_hate_grade = 0;

        //fivecore abcde
        this.hero_dressedHatGlassClothCount = 0;//0 1 2 3//个数
        this.hero_hat_grade = 0;//-1 0 1//帽子分数
        this.hero_glass_grade = 0;//-1 0 1//眼镜分数
        this.hero_cloth_grade = 0;//-1 0 1//衣服分数
        this.latestGrade = 0;// -1 1    [0]//最后那个的分数


        //用于脱掉衣服检测
        this.hero_cloth_remove = createRemovePropLayerColor("duck","cloth",this.hero,258,180,cc.p(1,125),100,-1,GlobalDuckLayer);//-1是默认啥都没穿
        this.hero_hat_remove = createRemovePropLayerColor("duck","hat",this.hero,240,120,cc.p(-2,390),100,-1,GlobalDuckLayer);//-1是默认啥都没穿
        this.hero_glass_remove = createRemovePropLayerColor("duck","glass",this.hero,200,80,cc.p(-1,280),100,-1,GlobalDuckLayer);//-1是默认啥都没穿
        if(this.hero_hat_index != "8") {
            this.hero_hat_remove.setEnable(true);
        }
        if(this.hero_glass_index != "4"){
            this.hero_glass_remove.setEnable(true);
        }
        if(this.hero_cloth_index != "b"){
            this.hero_cloth_remove.setEnable(true);
        }


        this.hero_all_touch = createTouchSpriteLayerColor("duck",this.hero,320,450,cc.p(-3,210),200,this);

        this.filtercloth = createFilterEventLayerColor(this,Config_Play.filterSprite.cloth.width,Config_Play.filterSprite.cloth.height,Config_Play.duck.prop_position.cloth,10);
        this.filterhat = createFilterEventLayerColor(this,Config_Play.filterSprite.hat.width,Config_Play.filterSprite.hat.height,Config_Play.duck.prop_position.hat,10);
        this.filterglass = createFilterEventLayerColor(this,Config_Play.filterSprite.glass.width,Config_Play.filterSprite.glass.height,Config_Play.duck.prop_position.glass,10);
    },
    getHeroLoveHateGrade:function(){
        this.hero_love_hate_grade = this.hero_hat_grade + this.hero_glass_grade + this.hero_cloth_grade;
        return this.hero_love_hate_grade;
    },
    setHeroDressedHatGlassClothCount:function(count){//0 1 2 3
        this.hero_dressedHatGlassClothCount = count;
    },
    getHeroDressedHatGlassClothCount:function(){//0 1 2 3
        return this.hero_dressedHatGlassClothCount;
    },
    getLatestDressUpOrDownIsLove:function(){//最近脱掉或穿上的是否是喜欢的
        if(this.latestGrade == -1) {
            return false;//不喜欢
        } else {
            return true;//最近那次喜欢
        }
    },
    setLastGrade:function(lastgrade){
        this.latestGrade = lastgrade;
    },
    getLastGrade:function(){
        return this.latestGrade;
    },
    //onecore
    updateAndHandleUp:function(a,b,c,d,e){
        cc.log(" ##### UP a = " + a +" , b = " + b +" , c = " + c +" , d " + d +" , e = " + e + "###########");
        this.updateFiveCore(a,b,c,d,e);
        this.handleDressUp();
    },
    updateAndHandleDown:function(a,b,c,d,e){
        cc.log(" ***** DW a = " + a +" , b = " + b +" , c = " + c +" , d " + d +" , e = " + e);
        this.updateFiveCore(a,b,c,d,e);
        this.handleDressDown();
    },
    //three core
    updateFiveCore:function(a,b,c,d,e){
        this.hero_dressedHatGlassClothCount = a;
        this.hero_hat_grade = b;
        this.hero_glass_grade = c;
        this.hero_cloth_grade = d;
        this.latestGrade = e;
    },
    handleDressUp:function(){//穿上
        this.timerManager.zeroDeltaSeconds();
        if(this.getLatestDressUpOrDownIsLove()){//如果最近一次是 喜欢
            if(1 == this.getHeroDressedHatGlassClothCount()){
                //随机love呼吸抖动
                this.randLove();
            }else if(this.getHeroDressedHatGlassClothCount() >= 2){
                //全喜欢 笑
                this.toLaugh();
            }
        }else{
            //最近穿上的是 讨厌
            if(1 == this.getHeroDressedHatGlassClothCount()){
                //随机hate呼吸抖动
                this.randHate();
            }else if(this.getHeroDressedHatGlassClothCount() >= 2){
                //全讨厌 哭
                this.toCry();
            }
        }
    },
    handleDressDown:function(){//脱掉
        this.timerManager.zeroDeltaSeconds();
        if(this.getLatestDressUpOrDownIsLove()){//最近脱掉的是 喜欢的
            cc.log("脱掉了喜欢的");
            if(0 == this.getHeroDressedHatGlassClothCount()){//只穿了一件,然后被脱了,不开心
                //随机hate呼吸抖动
                this.randHate();
            }else if(1 == this.getHeroDressedHatGlassClothCount()){//穿了两件,脱了一件喜欢的
                if(this.getHeroLoveHateGrade() == -1){//剩余的一件是讨厌的
                    //哭
                    this.toCry();
                }else{
                    //翻白眼
                    var idx = getRand0ToN(1);
                    if(0 == idx){
                        this.randHate();
                    }else{
                        this.toBaiyan();
                    }
                }
            }else if(2 == this.getHeroDressedHatGlassClothCount()){//穿了三件,脱了一件喜欢的
                if(this.getHeroLoveHateGrade() == -2){//剩余的两件都是讨厌的
                    //哭
                    this.toCry();
                }else{
                    //翻白眼
                    var idx = getRand0ToN(1);
                    if(0 == idx){
                        this.toCry();
                    }else{
                        this.toBaiyan();
                    }
                }
            }
        }else{
            cc.log("脱掉了讨厌的");
            //最近脱掉的是 讨厌的
            if(1 == this.getHeroDressedHatGlassClothCount()){
                //随机love呼吸抖动
                this.randLove();
            }else if(this.getHeroDressedHatGlassClothCount() >= 2){
                //全喜欢 笑
                this.toLaugh();
            }
        }
    },
    toCry:function(){
        ddStopAllEffects();
        ddPlayEffect("effect","res/K/audio/game/duck/cry.mp3",false);
        this.hero.setAnimation(1,"cry",false);
        this.timerManager.zeroDeltaSeconds();
    },
    toLaugh:function(){
        var clothidx = this.getClothIndexString();
        var hatidx = this.getHatIndexString();
        if(Config_Play.clothduck.names[revMapStr(clothidx)] == Config_Play.hatduck.names[revMapStr(hatidx)] && Config_Play.hatduck.names[revMapStr(hatidx)] == "shengdan"){
            //nothing
        }else{
            ddStopAllAudios();
        }
        ddPlayEffect("effect","res/K/audio/game/duck/laugh.mp3",false);
        this.hero.setAnimation(1,"laugh",false);
        this.timerManager.zeroDeltaSeconds();
    },
    toBaiyan:function(){
        ddStopAllEffects();
        ddPlayEffect("effect","res/K/audio/game/duck/baiyan.mp3",false);
        this.hero.setAnimation(1, 'shake4', false);
        this.setCurrentHeoBreathIdx(4);
        this.timerManager.zeroDeltaSeconds();
    },
    randHate:function(){
        switch (getRand0ToN(1)){
            case 0:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/duck/shengqi.mp3",false);
                this.hero.setAnimation(1, 'shake2', false);
                this.setCurrentHeoBreathIdx(2);
                break;
            case 1:
                ddStopAllEffects();
                ddPlayEffect("effect","res/K/audio/game/duck/bugaoxing.mp3",false);
                this.hero.setAnimation(1, 'shake3', false);
                this.setCurrentHeoBreathIdx(3);
                break;
            default:
                break;
        }
        this.timerManager.zeroDeltaSeconds();
    },
    randLove:function(){
        ddStopAllEffects();
        ddPlayEffect("effect","res/K/audio/game/duck/gaoxing.mp3",false);
        this.hero.setAnimation(1, 'shake', false);
        this.setCurrentHeoBreathIdx('');
        this.timerManager.zeroDeltaSeconds();
    },

    addEventManager:function(){
        this.eventManager = new EventManagerNode();
        this.addChild(this.eventManager);
    },
    addTimerManager:function(){
        this.timerManager = new CustomTimerNode(8,function(){
            var tmpIdx = getRand0ToN(2)+1;
            ddStopAllEffects();
            ddPlayEffect("effect","res/K/audio/game/duck/strech.mp3",false);
            this.hero.setAnimation(1,"strech"+tmpIdx,false);
        }.bind(this));
        this.addChild(this.timerManager);
    },
    enableHeroXRemove:function(){
        this.hero_cloth_remove.setEnable(true);
        this.hero_glass_remove.setEnable(true);
        this.hero_hat_remove.setEnable(true);
    },
    getHatIndexString:function(){
        return this.hero_hat_index;
    },
    getClothIndexString:function(){
        return this.hero_cloth_index;
    },
    getGlassIndexString:function(){
        return this.hero_glass_index;
    },
    setSkin:function(){
        this.hero.setSkin("skin"+this.hero_hat_index+this.hero_glass_index+this.hero_cloth_index);
    },
    setSkinByArg:function(a,b,c){
        this.hero.setSkin("skin"+a+b+c);
    },
    initGlobal:function(){
        // this.loveAnimationIdx = [1,7,8,9,10,11];
        // this.hateAnimationIdx = [2,3,4,5,6,12];
        // this.hateLoveIdx = [1,2,3,4,5,6,7,8,9,10,11,12];

        this.hero_breathIdx = '';
        this.hero_breathsufaftertype = Config_Play.breathsufAfterType.notype;
    },
    addPropManager:function(){
        // this.cloth = createSuperPropNode("duck","res/K/picture/common/cloth/cloth_emo.png","cloth_emo",this,Config_Play.duck.prop_position.cloth,100,1,180,240,Config_Play.propType.cloth);
        // cc.log("cloth.group =   "+this.cloth.shape.group+" ,cloth.layers =  " +this.cloth.shape.layers);

        var propPropertyHat = new PropProperty("duck","res/K/picture/common/",this,Config_Play.duck.prop_position.hat,15,1,180,140,Config_Play.propType.hat,"hat");
        var propHatCircleArray = ["haidao","wuxia","xiaochou","mofa","shuishou","shengshi","chushi","emo","jingcha","mifeng","shengdan"];
        this.propManagerHat = new PropManager("duck","HatManager",propHatCircleArray,propPropertyHat);
        this.addChild(this.propManagerHat);

        var propPropertyGlass = new PropProperty("duck","res/K/picture/common/",this,Config_Play.duck.prop_position.glass,15,1,180,80,Config_Play.propType.glass,"glass");
        var propGlassCircleArray = ["taohua","laohua","mo","3d","baikuang"];
        this.propManagerGlass = new PropManager("duck","GlassManager",propGlassCircleArray,propPropertyGlass);
        this.addChild(this.propManagerGlass);

        var propPropertyCloth = new PropProperty("duck","res/K/picture/common/",this,Config_Play.duck.prop_position.cloth,2,1,180,180,Config_Play.propType.cloth,"cloth");
        var propClothCircleArray = ["gongzhu","haidao","wuxia","xiaochou","mofa","shuishou","tianshi","shengshi","chushi","emo","jingcha","niuzai","mifeng","shengdan"];
        this.propManagerCloth = new PropManager("duck","ClothManager",propClothCircleArray,propPropertyCloth);
        this.addChild(this.propManagerCloth);
    },
    addDebugNode:function(){
        addRetMenu(this, Config_Select.return_btn, this.backOperation);
        backKeyListenerAdd(this,this.backOperation);
    },
    backOperation:function(){
        GlobalSelectLayer.cameraMenu.couldEnter = true;
        ddStopAllAudios();
        cc.audioEngine.stopMusic();
        cc.director.popScene();
    },
    getCurrentHeoBreathIdx:function(){
        return this.hero_breathIdx;
    },
    setCurrentHeoBreathIdx:function(idx){
        this.hero_breathIdx = idx;
    },
    handleCompleteStrechListener:function(animationname,idx){
        if(animationname == "strech"+idx){
            this.hero.setAnimation(1,"breath",true);
            this.timerManager.zeroDeltaSeconds();
        }
    },
    handleCompleteShakeListener:function(animationname,idx){
        if(animationname == "shake"+idx) {
            this.hero.setAnimation(1, 'breath' + idx, true);
            this.setCurrentHeoBreathIdx(idx);
            this.timerManager.zeroDeltaSeconds();
        }
    },
    handleCompleteLaughListener:function(animationame){
        if(animationame == "laugh") {
            this.hero.setAnimation(1, 'breath', true);
            this.setCurrentHeoBreathIdx('');
            this.timerManager.zeroDeltaSeconds();
        }
    },
    handleCompleteCryListener:function(animationame){
        if(animationame == "cry") {
            this.hero.setAnimation(1, 'breath', true);
            this.setCurrentHeoBreathIdx('');
            this.timerManager.zeroDeltaSeconds();
        }
    },
    initHero:function(){
        this.hero.setCompleteListener(function(trackEntry){

            if(trackEntry) {

                var animationName = trackEntry.animation ? trackEntry.animation.name : "nullname";

                if(animationName == "look around"){
                    GlobalDuckLayer.hero.setAnimation(1,'breath',true);
                    GlobalDuckLayer.hero.hero_breathIdx = '';
                }
                for(var idx = 1;idx <= 4;idx ++){
                    var tmp = (idx == 1) ? '' : idx;
                    GlobalDuckLayer.handleCompleteShakeListener(animationName,tmp);
                }
                for(var i = 1;i <= 3; i ++) {
                    GlobalDuckLayer.handleCompleteStrechListener(animationName, i);
                }
                GlobalDuckLayer.handleCompleteLaughListener(animationName);
                GlobalDuckLayer.handleCompleteCryListener(animationName);
            }
        });
    },
    update:function(dt){
        updatePhysics(this.space,dt);
    },
    collisionBegin:function(araiber,space){
        var shapeA = araiber.getShapes()[0];
        var shapeB = araiber.getShapes()[1];

        var bodyA = shapeA.getBody();
        var bodyB = shapeB.getBody();

        var spriteA = bodyA.datas;
        var spriteB = bodyB.datas;

        var shape = shapeA.collision_type == 1001 ? shapeA : shapeB;
        var body = shapeA.collision_type == 1001 ? bodyA : bodyB;
        var sprite = shapeA.collision_type == 1001 ? spriteA : spriteB;
        this.space.addPostStepCallback(function(){
            try{
                GlobalDuckLayer.space.removeBody(body);
                GlobalDuckLayer.space.removeShape(shape);
            }
            catch (error){
                cc.log("collisionBegin : already be moved !!!");
            }
            if(sprite){
                if(sprite.proptype == Config_Play.propType.cloth) {
                    if (!GlobalDuckLayer.hero_cloth_flag_have && !sprite.isNormal) {
                        GlobalDuckLayer.createSafePropCloth();
                        GlobalDuckLayer.hero_cloth_flag_have = true;
                    } else {
                        GlobalDuckLayer.hero_cloth_flag_have = false;
                    }
                }
                if(sprite.proptype == Config_Play.propType.glass) {
                    if (!GlobalDuckLayer.hero_glass_flag_have && !sprite.isNormal) {
                        GlobalDuckLayer.createSafePropGlass();
                        GlobalDuckLayer.hero_glass_flag_have = true;
                    } else {
                        GlobalDuckLayer.hero_glass_flag_have = false;
                    }
                }
                if(sprite.proptype == Config_Play.propType.hat) {
                    if (!GlobalDuckLayer.hero_hat_flag_have && !sprite.isNormal) {
                        GlobalDuckLayer.createSafePropHat();
                        GlobalDuckLayer.hero_hat_flag_have = true;
                    } else {
                        GlobalDuckLayer.hero_hat_flag_have = false;
                    }
                }
                sprite.removeFromParent(true);
                sprite = null;
            }
        });
        return false;
    },
    startGame:function(){
        cc.log("开始游戏");
        this.hero.setAnimation(1,'look around',false);
        this.hero_all_touch.setEnable(true);

        this.updateFiveCore(0,0,0,0,0);

        this.timerManager.startTimer();
        this.scheduleOnce(function(){
            ddPlayEffect("effect","res/K/audio/game/cloth_out.mp3",false);
            this.createSafePropCloth();
            this.filtercloth.isFilterEvent(false);
        }.bind(this),0);
        this.scheduleOnce(function(){
            ddPlayEffect("effect","res/K/audio/game/hat_out.mp3",false);
            this.createSafePropHat();
            this.filterhat.isFilterEvent(false);
        }.bind(this),0.5);
        this.scheduleOnce(function(){
            ddPlayEffect("effect","res/K/audio/game/glass_out.mp3",false);
            this.createSafePropGlass();
            this.filterglass.isFilterEvent(false);
        }.bind(this),1);
    },
    createSafePropCloth:function(){
        GlobalDuckLayer.propManagerCloth.gotoNextAndCreateAProp(Config_Play.clothduck.names[revMapStr(GlobalDuckLayer.hero_cloth_index)]);
    },
    createSafePropGlass:function(){
        GlobalDuckLayer.propManagerGlass.gotoNextAndCreateAProp(Config_Play.glassduck.names[revMapStr(GlobalDuckLayer.hero_glass_index)]);
    },
    createSafePropHat:function(){
        GlobalDuckLayer.propManagerHat.gotoNextAndCreateAProp(Config_Play.hatduck.names[revMapStr(GlobalDuckLayer.hero_hat_index)]);
    }
});

var DuckScene = cc.Scene.extend({
    customFlag:null,
    ctor:function () {
        this._super();
        this.customFlag = 0;
        umengEvent("animal_type", "Duck");
        var layer = new DuckLayer();
        this.addChild(layer);
    }
});

