var HeadSprite = cc.Sprite.extend({
	name_dragon:null,
	ctor:function(dragon_name){
		this._super();
		if (dragon_name) {
			this.setTexture(headPath(dragon_name));
			this.name_dragon = dragon_name;
		}
	},
	setDragon:function(dragon_name){
		this.name_dragon = dragon_name;
		this.setTexture(headPath(dragon_name));
	},
	getDragon:function(){
		return this.name_dragon;
	}
});

var ToolSprite = cc.Sprite.extend({
	name_tool:null,
	dragon_name:null,
	ctor:function(dragon_name, tool_name){
		this._super();
		if (dragon_name && tool_name) {
			this.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame(toolPath(dragon_name, tool_name)));
			this.dragon_name = dragon_name;
			this.name_tool = tool_name;
		}
	},
	setTool:function(dragon_name, tool_name){
		this.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame(toolPath(dragon_name, tool_name)));
		this.name_tool = tool_name;
		this.dragon_name = dragon_name;
	},
	toolName:function(){
		return this.name_tool;
	}
});

var DragonSprite = cc.Sprite.extend({
	name_dragon:null,
	enable:null,
	ctor:function(dragon_name){
		this._super();
		if (dragon_name) {
			this.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame(dragonPath(dragon_name)));
			this.name_dragon = dragon_name;
		}
		
		this.enable = true;
	},
	setDragon:function(dragon_name){
		this.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame(dragonPath(dragon_name)));
		this.name_dragon = dragon_name;
	},
	dragonName:function(){
		return this.name_dragon;
	},
	setEnable:function(enable){
		this.enable = enable;
	},
	isEnable:function(){
		return this.enable;
	}
});

var MenuSingleSprite = cc.Sprite.extend({
	enable:null,
	ctor:function(frame_name){
		this._super(frame_name);
		this.enable = true;
	},
	setEnable:function(enable){
		this.enable = enable;
	},
	isEnable:function(){
		return this.enable;
	}
});

